Index: pjproject/trunk/pjsip-apps/src/python/_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2158)
+++ pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2163)
@@ -3453,5 +2379,4 @@
     status = pjsua_conf_disconnect(source, sink);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3460,6 +2385,5 @@
  * py_pjsua_conf_set_tx_level
  */
-static PyObject *py_pjsua_conf_set_tx_level
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_conf_set_tx_level(PyObject *pSelf, PyObject *pArgs)
 {    	
     int slot;
@@ -3469,6 +2393,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "if", &slot, &level))
-    {
+    if (!PyArg_ParseTuple(pArgs, "if", &slot, &level)) {
         return NULL;
     }	
@@ -3476,5 +2399,4 @@
     status = pjsua_conf_adjust_tx_level(slot, level);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3483,6 +2405,5 @@
  * py_pjsua_conf_set_rx_level
  */
-static PyObject *py_pjsua_conf_set_rx_level
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_conf_set_rx_level(PyObject *pSelf, PyObject *pArgs)
 {    	
     int slot;
@@ -3492,6 +2413,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "if", &slot, &level))
-    {
+    if (!PyArg_ParseTuple(pArgs, "if", &slot, &level)) {
         return NULL;
     }	
@@ -3499,5 +2419,4 @@
     status = pjsua_conf_adjust_rx_level(slot, level);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3506,6 +2425,6 @@
  * py_pjsua_conf_get_signal_level
  */
-static PyObject *py_pjsua_conf_get_signal_level
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_conf_get_signal_level(PyObject *pSelf, 
+						PyObject *pArgs)
 {    	
     int slot;
@@ -3515,6 +2434,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "i", &slot))
-    {
+    if (!PyArg_ParseTuple(pArgs, "i", &slot)) {
         return NULL;
     }	
@@ -3522,7 +2440,6 @@
     status = pjsua_conf_get_signal_level(slot, &tx_level, &rx_level);
     
-    
     return Py_BuildValue("iff", status, (float)(tx_level/255.0), 
-			        (float)(rx_level/255.0));
+			 (float)(rx_level/255.0));
 }
 
@@ -3530,22 +2447,20 @@
  * py_pjsua_player_create
  */
-static PyObject *py_pjsua_player_create
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_player_create(PyObject *pSelf, PyObject *pArgs)
 {    	
     int id;
     int options;
-    PyObject * filename;
-    pj_str_t str;
+    PyObject *pFilename;
+    pj_str_t filename;
     int status;	
     
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "Oi", &filename, &options))
-    {
-        return NULL;
-    }	
-    str.ptr = PyString_AsString(filename);
-    str.slen = strlen(PyString_AsString(filename));
-    status = pjsua_player_create(&str, options, &id);
+    if (!PyArg_ParseTuple(pArgs, "Oi", &pFilename, &options)) {
+        return NULL;
+    }
+
+    filename = PyString_ToPJ(pFilename);
+    status = pjsua_player_create(&filename, options, &id);
     
     return Py_BuildValue("ii", status, id);
@@ -3555,10 +2470,9 @@
  * py_pjsua_playlist_create
  */
-static PyObject *py_pjsua_playlist_create
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_playlist_create(PyObject *pSelf, PyObject *pArgs)
 {    	
     int id;
     int options;
-    PyObject *arg_label, *arg_filelist;
+    PyObject *pLabel, *pFileList;
     pj_str_t label;
     int count;
@@ -3568,46 +2482,41 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "OOi", &arg_label, &arg_filelist, &options))
-    {
+    if (!PyArg_ParseTuple(pArgs, "OOi", &pLabel, &pFileList, &options)) {
+        return NULL;
+    }
+
+    label = PyString_ToPJ(pLabel);
+    if (!PyList_Check(pFileList))
+	return Py_BuildValue("ii", PJ_EINVAL, PJSUA_INVALID_ID);
+
+    count = 0;
+    for (count=0; count<PyList_Size(pFileList) && 
+		  count<PJ_ARRAY_SIZE(files); ++count) 
+    {
+	files[count] = PyString_ToPJ(PyList_GetItem(pFileList, count));
+    }
+
+    status = pjsua_playlist_create(files, count, &label, options, &id);
+    
+    return Py_BuildValue("ii", status, id);
+}
+
+/*
+ * py_pjsua_player_get_conf_port
+ */
+static PyObject *py_pjsua_player_get_conf_port(PyObject *pSelf, 
+					       PyObject *pArgs)
+{    	
+    
+    int id, port_id;	
+    
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
         return NULL;
     }	
-    label.ptr = PyString_AsString(arg_label);
-    label.slen = PyString_Size(arg_label);
-
-    if (!PyList_Check(arg_filelist))
-	return NULL;
-
-    count = 0;
-    for (count=0; count<PyList_Size(arg_filelist) && 
-		  count<PJ_ARRAY_SIZE(files); ++count) 
-    {
-	files[count].ptr = PyString_AsString(PyList_GetItem(arg_filelist, count));
-	files[count].slen = PyString_Size(PyList_GetItem(arg_filelist, count));
-    }
-
-    status = pjsua_playlist_create(files, count, &label, options, &id);
-    
-    return Py_BuildValue("ii", status, id);
-}
-
-/*
- * py_pjsua_player_get_conf_port
- */
-static PyObject *py_pjsua_player_get_conf_port
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-    
-    int id, port_id;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
-        return NULL;
-    }	
     
     port_id = pjsua_player_get_conf_port(id);
     
-    
     return Py_BuildValue("i", port_id);
 }
@@ -3616,21 +2525,21 @@
  * py_pjsua_player_set_pos
  */
-static PyObject *py_pjsua_player_set_pos
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_player_set_pos(PyObject *pSelf, PyObject *pArgs)
 {    	
     int id;
-    pj_uint32_t samples;
+    int samples;
     int status;	
     
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "iI", &id, &samples))
-    {
+    if (!PyArg_ParseTuple(pArgs, "ii", &id, &samples)) {
         return NULL;
     }	
     
+    if (samples < 0)
+	samples = 0;
+
     status = pjsua_player_set_pos(id, samples);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3639,6 +2548,5 @@
  * py_pjsua_player_destroy
  */
-static PyObject *py_pjsua_player_destroy
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_player_destroy(PyObject *pSelf, PyObject *pArgs)
 {    	
     int id;
@@ -3647,6 +2555,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
         return NULL;
     }	
@@ -3654,5 +2561,4 @@
     status = pjsua_player_destroy(id);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3660,16 +2566,11 @@
 /*
  * py_pjsua_recorder_create
- * !modified @ 261206
- */
-static PyObject *py_pjsua_recorder_create
-(PyObject *pSelf, PyObject *pArgs)
+ */
+static PyObject *py_pjsua_recorder_create(PyObject *pSelf, PyObject *pArgs)
 {    	
-    int p_id;
-    int options;
+    int id, options;
     int max_size;
-    PyObject * filename;
-    pj_str_t str;
-    PyObject * enc_param;
-    pj_str_t strparam;
+    PyObject *pFilename, *pEncParam;
+    pj_str_t filename;
     int enc_type;
     
@@ -3678,43 +2579,35 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "OiOii", &filename, 
-		&enc_type, &enc_param, &max_size, &options))
-    {
+    if (!PyArg_ParseTuple(pArgs, "OiOii", &pFilename, &enc_type, &pEncParam,
+			  &max_size, &options))
+    {
+        return NULL;
+    }
+
+    filename = PyString_ToPJ(pFilename);
+
+    status = pjsua_recorder_create(&filename, enc_type, NULL, max_size,
+				   options, &id);
+
+    return Py_BuildValue("ii", status, id);
+}
+
+/*
+ * py_pjsua_recorder_get_conf_port
+ */
+static PyObject *py_pjsua_recorder_get_conf_port(PyObject *pSelf, 
+						 PyObject *pArgs)
+{    	
+    
+    int id, port_id;	
+    
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
         return NULL;
     }	
-    str.ptr = PyString_AsString(filename);
-    str.slen = strlen(PyString_AsString(filename));
-    if (enc_param != Py_None)
-    {
-        strparam.ptr = PyString_AsString(enc_param);
-        strparam.slen = strlen(PyString_AsString(enc_param));
-        status = pjsua_recorder_create
-		(&str, enc_type, NULL, max_size, options, &p_id);
-    } else {
-        status = pjsua_recorder_create
-		(&str, enc_type, NULL, max_size, options, &p_id);
-    }
-    return Py_BuildValue("ii", status, p_id);
-}
-
-/*
- * py_pjsua_recorder_get_conf_port
- */
-static PyObject *py_pjsua_recorder_get_conf_port
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-    
-    int id, port_id;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
-        return NULL;
-    }	
     
     port_id = pjsua_recorder_get_conf_port(id);
     
-    
     return Py_BuildValue("i", port_id);
 }
@@ -3723,6 +2616,5 @@
  * py_pjsua_recorder_destroy
  */
-static PyObject *py_pjsua_recorder_destroy
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_recorder_destroy(PyObject *pSelf, PyObject *pArgs)
 {    	
     int id;
@@ -3731,6 +2623,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
         return NULL;
     }	
@@ -3738,5 +2629,4 @@
     status = pjsua_recorder_destroy(id);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3748,48 +2638,32 @@
 {
     pj_status_t status;
-    PyObject *list;
-    
+    PyObject *ret;
     pjmedia_snd_dev_info info[SND_DEV_NUM];
     unsigned c, i;
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pArgs);
+
     c = PJ_ARRAY_SIZE(info);
     status = pjsua_enum_snd_devs(info, &c);
-    
-    list = PyList_New(c);
-    for (i = 0; i < c; i++) 
-    {
-        int ret;
-        int j;
-        char * str;
-	
+    if (status != PJ_SUCCESS)
+	c = 0;
+    
+    ret = PyList_New(c);
+    for (i = 0; i < c; i++)  {
         PyObj_pjmedia_snd_dev_info * obj;
-        obj = (PyObj_pjmedia_snd_dev_info *)pjmedia_snd_dev_info_new
-	    (&PyTyp_pjmedia_snd_dev_info, NULL, NULL);
+
+        obj = (PyObj_pjmedia_snd_dev_info *)
+	      pjmedia_snd_dev_info_new(&PyTyp_pjmedia_snd_dev_info, 
+				       NULL, NULL);
         obj->default_samples_per_sec = info[i].default_samples_per_sec;
         obj->input_count = info[i].input_count;
         obj->output_count = info[i].output_count;
-        str = (char *)malloc(SND_NAME_LEN * sizeof(char));
-        memset(str, 0, SND_NAME_LEN);
-        for (j = 0; j < SND_NAME_LEN; j++)
-	{
-            str[j] = info[i].name[j];
-	}
-        obj->name = PyString_FromStringAndSize(str, SND_NAME_LEN);
-        free(str);
-        ret = PyList_SetItem(list, i, (PyObject *)obj);
-        if (ret == -1) 
-	{
-            return NULL;
-	}
-    }
-    
-    return Py_BuildValue("O",list);
+        obj->name = PyString_FromString(info[i].name);
+
+        PyList_SetItem(ret, i, (PyObject *)obj);
+    }
+    
+    return (PyObject*)ret;
 }
 
@@ -3797,6 +2671,5 @@
  * py_pjsua_get_snd_dev
  */
-static PyObject *py_pjsua_get_snd_dev
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_get_snd_dev(PyObject *pSelf, PyObject *pArgs)
 {    	
     int capture_dev, playback_dev;
@@ -3804,13 +2677,8 @@
     
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pArgs);
+
     status = pjsua_get_snd_dev(&capture_dev, &playback_dev);
     
-    
     return Py_BuildValue("ii", capture_dev, playback_dev);
 }
@@ -3819,6 +2687,5 @@
  * py_pjsua_set_snd_dev
  */
-static PyObject *py_pjsua_set_snd_dev
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_set_snd_dev(PyObject *pSelf, PyObject *pArgs)
 {    	
     int capture_dev, playback_dev;
@@ -3827,6 +2694,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &capture_dev, &playback_dev))
-    {
+    if (!PyArg_ParseTuple(pArgs, "ii", &capture_dev, &playback_dev)) {
         return NULL;
     }	
@@ -3834,5 +2700,4 @@
     status = pjsua_set_snd_dev(capture_dev, playback_dev);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3841,50 +2706,20 @@
  * py_pjsua_set_null_snd_dev
  */
-static PyObject *py_pjsua_set_null_snd_dev
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_set_null_snd_dev(PyObject *pSelf, PyObject *pArgs)
 {    	
-    
     int status;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+
+    PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
+
     status = pjsua_set_null_snd_dev();
-    
-    
+
     return Py_BuildValue("i", status);
 }
 
 /*
- * py_pjsua_set_no_snd_dev
- */
-static PyObject *py_pjsua_set_no_snd_dev
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-    
-    PyObj_pjmedia_port * obj;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-     
-    obj = (PyObj_pjmedia_port *)PyType_GenericNew
-	(&PyTyp_pjmedia_port, NULL, NULL);
-    obj->port = pjsua_set_no_snd_dev();
-    return Py_BuildValue("O", obj);
-}
-
-/*
  * py_pjsua_set_ec
  */
-static PyObject *py_pjsua_set_ec
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_set_ec(PyObject *pSelf, PyObject *pArgs)
 {    	
     int options;
@@ -3894,12 +2729,10 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &tail_ms, &options))
-    {
+    if (!PyArg_ParseTuple(pArgs, "ii", &tail_ms, &options)) {
         return NULL;
     }	
-    
+
     status = pjsua_set_ec(tail_ms, options);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3908,69 +2741,49 @@
  * py_pjsua_get_ec_tail
  */
-static PyObject *py_pjsua_get_ec_tail
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_get_ec_tail(PyObject *pSelf, PyObject *pArgs)
 {    	
-    
     int status;	
-    unsigned p_tail_ms;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
-    status = pjsua_get_ec_tail(&p_tail_ms);
-    
-    
-    return Py_BuildValue("i", p_tail_ms);
+    unsigned tail_ms;
+
+    PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
+
+    status = pjsua_get_ec_tail(&tail_ms);
+    if (status != PJ_SUCCESS)
+	tail_ms = 0;
+    
+    return Py_BuildValue("i", tail_ms);
 }
 
 /*
  * py_pjsua_enum_codecs
- * !modified @ 261206
  */
 static PyObject *py_pjsua_enum_codecs(PyObject *pSelf, PyObject *pArgs)
 {
     pj_status_t status;
-    PyObject *list;
-    
+    PyObject *ret;
     pjsua_codec_info info[PJMEDIA_CODEC_MGR_MAX_CODECS];
     unsigned c, i;
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pArgs);
+
     c = PJ_ARRAY_SIZE(info);
     status = pjsua_enum_codecs(info, &c);
-    
-    list = PyList_New(c);
-    for (i = 0; i < c; i++) 
-    {
-        int ret;
-        int j;
+    if (status != PJ_SUCCESS)
+	c = 0;
+    
+    ret = PyList_New(c);
+    for (i = 0; i < c; i++)  {
         PyObj_pjsua_codec_info * obj;
-        obj = (PyObj_pjsua_codec_info *)codec_info_new
-	    (&PyTyp_pjsua_codec_info, NULL, NULL);
-        obj->codec_id = PyString_FromStringAndSize
-	    (info[i].codec_id.ptr, info[i].codec_id.slen);
+        obj = (PyObj_pjsua_codec_info *)
+	      codec_info_new(&PyTyp_pjsua_codec_info, NULL, NULL);
+        obj->codec_id = PyString_FromPJ(&info[i].codec_id);
         obj->priority = info[i].priority;
-        for (j = 0; j < 32; j++)
-        {	    
-             obj->buf_[j] = info[i].buf_[j];
-        }	
-        ret = PyList_SetItem(list, i, (PyObject *)obj);
-        if (ret == -1) {
-            return NULL;
-        }	
-    }
-    
-
-    return Py_BuildValue("O",list);
+
+        PyList_SetItem(ret, i, (PyObject *)obj);
+    }
+
+    return (PyObject*)ret;
 }
 
@@ -3978,94 +2791,95 @@
  * py_pjsua_codec_set_priority
  */
-static PyObject *py_pjsua_codec_set_priority
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_codec_set_priority(PyObject *pSelf, PyObject *pArgs)
 {    	
-    
     int status;	
-    PyObject * id;
-    pj_str_t str;
-    pj_uint8_t priority;
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "OB", &id, &priority))
-    {
+    PyObject *pCodecId;
+    pj_str_t codec_id;
+    int priority;
+    
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "Oi", &pCodecId, &priority)) {
+        return NULL;
+    }
+
+    codec_id = PyString_ToPJ(pCodecId);
+    if (priority < 0)
+	priority = 0;
+    if (priority > 255)
+	priority = 255;
+
+    status = pjsua_codec_set_priority(&codec_id, (pj_uint8_t)priority);
+    
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_codec_get_param
+ */
+static PyObject *py_pjsua_codec_get_param(PyObject *pSelf, PyObject *pArgs)
+{    	
+    int status;	
+    PyObject *pCodecId;
+    pj_str_t codec_id;
+    pjmedia_codec_param param;
+    PyObj_pjmedia_codec_param *ret;
+    
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "O", &pCodecId)) {
         return NULL;
     }	
-    str.ptr = PyString_AsString(id);
-    str.slen = strlen(PyString_AsString(id));
-    status = pjsua_codec_set_priority(&str, priority);
-    
-    
-    return Py_BuildValue("i", status);
-}
-
-/*
- * py_pjsua_codec_get_param
- */
-static PyObject *py_pjsua_codec_get_param
-(PyObject *pSelf, PyObject *pArgs)
+
+    codec_id = PyString_ToPJ(pCodecId);
+
+    status = pjsua_codec_get_param(&codec_id, &param);
+    if (status != PJ_SUCCESS)
+	return Py_BuildValue("");
+
+    ret = (PyObj_pjmedia_codec_param *)
+	  pjmedia_codec_param_new(&PyTyp_pjmedia_codec_param, NULL, NULL);
+
+    ret->info->avg_bps = param.info.avg_bps;
+    ret->info->channel_cnt = param.info.channel_cnt;
+    ret->info->clock_rate = param.info.clock_rate;
+    ret->info->frm_ptime = param.info.frm_ptime;
+    ret->info->pcm_bits_per_sample = param.info.pcm_bits_per_sample;
+    ret->info->pt = param.info.pt;
+    ret->setting->cng = param.setting.cng;
+    ret->setting->dec_fmtp_mode = param.setting.dec_fmtp_mode;
+    ret->setting->enc_fmtp_mode = param.setting.enc_fmtp_mode;
+    ret->setting->frm_per_pkt = param.setting.frm_per_pkt;
+    ret->setting->penh = param.setting.penh;
+    ret->setting->plc = param.setting.plc;
+    ret->setting->vad = param.setting.vad;
+
+    return (PyObject*)ret;
+}
+
+
+/*
+ * py_pjsua_codec_set_param
+ */
+static PyObject *py_pjsua_codec_set_param(PyObject *pSelf, PyObject *pArgs)
 {    	
-    
     int status;	
-    PyObject * id;
-    pj_str_t str;
+    PyObject *pCodecId, *pCodecParam;
+    pj_str_t codec_id;
     pjmedia_codec_param param;
-    PyObj_pjmedia_codec_param *obj;
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "O", &id))
-    {
+    
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "OO", &pCodecId, &pCodecParam)) {
         return NULL;
     }	
-    str.ptr = PyString_AsString(id);
-    str.slen = strlen(PyString_AsString(id));
-    status = pjsua_codec_get_param(&str, &param);
-    obj = (PyObj_pjmedia_codec_param *)pjmedia_codec_param_new
-	(&PyTyp_pjmedia_codec_param, NULL, NULL);
-    obj->info->avg_bps = param.info.avg_bps;
-    obj->info->channel_cnt = param.info.channel_cnt;
-    obj->info->clock_rate = param.info.clock_rate;
-    obj->info->frm_ptime = param.info.frm_ptime;
-    obj->info->pcm_bits_per_sample = param.info.pcm_bits_per_sample;
-    obj->info->pt = param.info.pt;
-    obj->setting->cng = param.setting.cng;
-    obj->setting->dec_fmtp_mode = param.setting.dec_fmtp_mode;
-    obj->setting->enc_fmtp_mode = param.setting.enc_fmtp_mode;
-    obj->setting->frm_per_pkt = param.setting.frm_per_pkt;
-    obj->setting->penh = param.setting.penh;
-    obj->setting->plc = param.setting.plc;
-    obj->setting->reserved = param.setting.reserved;
-    obj->setting->vad = param.setting.vad;
-
-    return Py_BuildValue("O", obj);
-}
-/*
- * py_pjsua_codec_set_param
- */
-static PyObject *py_pjsua_codec_set_param
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-    
-    int status;	
-    PyObject * id;
-    pj_str_t str;
-    pjmedia_codec_param param;
-    PyObject * tmpObj;
-    PyObj_pjmedia_codec_param *obj;
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "OO", &id, &tmpObj))
-    {
-        return NULL;
-    }	
-
-    str.ptr = PyString_AsString(id);
-    str.slen = strlen(PyString_AsString(id));
-    if (tmpObj != Py_None)
-    {
-        obj = (PyObj_pjmedia_codec_param *)tmpObj;
+
+    codec_id = PyString_ToPJ(pCodecId);
+
+    if (pCodecParam != Py_None) {
+	PyObj_pjmedia_codec_param *obj;
+
+        obj = (PyObj_pjmedia_codec_param *)pCodecParam;
+
         param.info.avg_bps = obj->info->avg_bps;
         param.info.channel_cnt = obj->info->channel_cnt;
@@ -4080,10 +2894,11 @@
         param.setting.penh = obj->setting->penh;
         param.setting.plc = obj->setting->plc;
-        param.setting.reserved = obj->setting->reserved;
         param.setting.vad = obj->setting->vad;
-        status = pjsua_codec_set_param(&str, &param);
+        status = pjsua_codec_set_param(&codec_id, &param);
+
     } else {
-        status = pjsua_codec_set_param(&str, NULL);
-    }
+        status = pjsua_codec_set_param(&codec_id, NULL);
+    }
+
     return Py_BuildValue("i", status);
 }
@@ -4101,12 +2916,4 @@
     "_pjsua.Conf_Port_Info _pjsua.conf_get_port_info (int id) "
     "Get information about the specified conference port";
-static char pjsua_conf_add_port_doc[] =
-    "int, int _pjsua.conf_add_port "
-    "(_pjsua.Pj_Pool pool, _pjsua.PJMedia_Port port) "
-    "Add arbitrary media port to PJSUA's conference bridge. "
-    "Application can use this function to add the media port "
-    "that it creates. For media ports that are created by PJSUA-LIB "
-    "(such as calls, file player, or file recorder), PJSUA-LIB will "
-    "automatically add the port to the bridge.";
 static char pjsua_conf_remove_port_doc[] =
     "int _pjsua.conf_remove_port (int id) "
@@ -4173,9 +2980,4 @@
     "provides the timing needed by the conference bridge, and will not "
     "interract with any hardware.";
-static char pjsua_set_no_snd_dev_doc[] =
-    "_pjsua.PJMedia_Port _pjsua.set_no_snd_dev () "
-    "Disconnect the main conference bridge from any sound devices, "
-    "and let application connect the bridge to it's "
-    "own sound device/master port.";
 static char pjsua_set_ec_doc[] =
     "int _pjsua.set_ec (int tail_ms, int options) "
